        character*5 function kmi_inst_type(
     *		header_version, instr_code, dsp_blk_ver)

! Last updated 2003/09/17

	integer*2 header_version
	integer*2 dsp_blk_ver
	byte instr_code

	kmi_inst_type = '     '

	if (header_version .eq. 120 .or. header_version .eq. 150) then
          kmi_inst_type = 'MtWh'

	else
	  if (instr_code .eq. 10) then
            kmi_inst_type = 'Maka '     ! used to be Everest
          else if (instr_code .eq. 20) then  ! "inst_code" replace by "instr_code", DMB, 02 June 09
            kmi_inst_type = 'ETNA '
	  else
	    select case (dsp_blk_ver)
					! DSP version
	      case (100)		! 1.00	12/95
                kmi_inst_type = 'Etna '                 ! Etna                 
              case (101)                ! 1.01
                kmi_inst_type = 'Etna '                 ! Etna                 
	      case (121)		! 1.21	02/97
                kmi_inst_type = 'Etna '                 ! Etna                 
	      case (122)		! 1.22	02/99
                kmi_inst_type = 'Etna '                 ! Etna 
	      case (123)		! 1.23  12/00  confirm at KMI website - cds 05/25/2001
                kmi_inst_type = 'Etna '                 ! Etna basic 3 channel 
              case (124)                ! 1.24
                kmi_inst_type = 'Etna '                 ! Etna 
	      case (22)			! 0.22	03/96
	      case (59)			! 0.59	05/96
	      case (63)			! 0.63	07/96
	      case (67)			! 0.67	09/96
	      case (80)			! 0.80	01/97
	      case (81)			! 0.81	06/97
	      case (8372)		! h.83	07/97  confirmed at KMI website - cds 05/25/2001
                kmi_inst_type = 'Etna '                 ! Etna-SI 3 channel w/ext RAM
              case (6890)               ! d.90  11/97
	      case (6591)		! a.91	04/97
	      case (6691)
	      case (6791)
	      case (6891)
	      case (6991)
	      case (7091)
	      case (7191)
	      case (7291)
	      case (7391)
	      case (7491)
	      case (7591)		! k.91	04/99
                kmi_inst_type = 'Etna '                 ! Etna-SI
	      case (6504)		! a.04	04/98
	      case (7004)		! f.04	04/98
	      case (8004)		! p.04	04/98
	      case (8104)		! q.04	11/98
	      case (6705)		! c.05	01/99
	      case (7105)		! g.05	05/99
	      case (7205)		! h.05	07/99
                kmi_inst_type = 'Etna '                 ! EtnaJM
	      case default
		kmi_inst_type = 'K2   '
	    end select
	  endif
	endif

	return

	end
      subroutine geocen(stlat, stlon, eqlat, eqlon, delta, az0, az1)
c
c   geocen - calculate geocentric positions, distances, and azimuths
c	on input:
c	  latitude and longitude are in decimal deg
c		(convention is north and east positive)
c	on output:
c	  delta is in km
c	  az0 (epicenter-to-station) and baz in deg
c
c      modified by c. stephens from version written by b. julian
c
	parameter(pi=3.14159265359)
	parameter(twopi=2.0d0*pi)
	parameter(rpd=pi/180.0d0)
	parameter(deg=180.0d0/pi)
	parameter (equrad = 6378.2064)
	parameter (polrad = 6356.5838)
c	parameter (flat = (equrad - polrad)/equrad)
c
c  compute epicenter variables
c
      gclat = ggtogc(eqlat*rpd)
      st0 = cos(gclat)
      ct0 = sin(gclat)
      phi0 = eqlon*rpd
c
c---- use approximation of local radius for derivative of surface
c----     distance with geocentric latitude.
c----  more accurate formulation would be:
c      drdth = -r**3 * cos(alat)*sin(alat)*( (1.-flat)**(-2) - 1. )/a**2
c      dsd = sqrt(drdth**2 + r**2)
c
	radius = ((cos(gclat)/equrad)**2+(sin(gclat)/polrad)**2)**(-.5)
c
c  compute station variables
c
      gclat = ggtogc(stlat*rpd)
      ct1 = sin(gclat)
      st1 = cos(gclat)
      sdlon = sin(stlon*rpd - phi0)
      cdlon = cos(stlon*rpd - phi0)
      cdelt = st0*st1*cdlon + ct0*ct1
      call cvrtop(st0*ct1-st1*ct0*cdlon, st1*sdlon, sdelt, az0)
      delta = atan2(sdelt, cdelt)
      call cvrtop(st1*ct0-st0*ct1*cdlon, -sdlon*st0, sdelt, az1)
      if (az0 .lt. 0.0) az0 = az0 + twopi
      if (az1 .lt. 0.0) az1 = az1 + twopi

      delta = delta*radius
      az0 = az0*deg
      az1 = az1*deg

      return
c
c   back - calculate geocentric coordinates of secondary point from
c          delat, az
c
c     entry back(delta, az0, alat, alon)
c     sdelt = sin(delta)
c     cdelt = cos(delta)
c     cz0 = cos(az0)
c     ct1 = st0*sdelt*cz0 + ct0*cdelt
c     call cvrtop(st0*cdelt-ct0*sdelt*cz0, sdelt*sin(az0), st1, dlon)
c     alat = atan2(ct1, st1)
c     alon = phi0 + dlon
c     if (abs(alon) .gt. pi) alon = alon - sign(twopi, alon)
c     return

      end
c
      function ggtogc(alat)
c
c     ggtogc - convert from geographic to geocentric latitude
c       (modified by c. stephens from version written by b. julian)
c
      real*4 ggtogc, alat

      parameter(halfpi=0.5d0*3.14159265359)

        flat = 3.3529e-03
        c1 = (1.0 - flat)**2
        c2 = halfpi*(1.0/c1 - 1.0)

c     data c1/9.933054e-01/
c     data c2/1.058656e-02/
      data thmax/0.02/
c
      if ((halfpi - abs(alat)) .lt. thmax) go to 1
      ggtogc = atan(c1*tan(alat))
      return
c
    1 ggtogc = alat/c1 - sign(c2,alat)
      return
c
c       gctogg - convert from geocentric to geographic latitude
c
c     entry gctogg(alat)
c     if ((halfpi - abs(alat)) .lt. thmax) go to 2
c     gctogg = atan(tan(alat)/c1)
c     return
c
c   2 gctogg = c1*(alat + sign(c2,alat))
c     return

      end
c
      subroutine cvrtop(x, y, r, theta)
c
c-------- bruce julian
c
c-------- cvrtop - convert from rectangular to polar coordinates
c
c-------- standard fortran function required:  atan2
c-------- function required:  hypot
c
      r = hypot(x, y)
      theta = 0.
      if((y .ne. 0.) .or. (x .ne. 0.)) theta = atan2(y, x)
      return
      end
c
      real function hypot(a, b)
c
c-------- bruce julian
c
c
c-------- hypot - calculates euclidian distance, accurately and
c            avoids overflow
c
      real a, b
      real abs, l, s, t, sqrt
      l = abs(a)
      s = abs(b)
      if (s .le. l) goto 1
         t = s
         s = l
         l = t
   1  if (l .ne. 0.0) goto 2
         hypot = 0.0
         return
   2  s = s/l
      hypot = l*sqrt(s*s+1.0)
      return
      end
	integer*4 function load_evt_seis(io_buff, isize, koff,
     *    seis, nsamples, lune, n_corrupt_segments,
     *    kff_tag, kff_file_descr,
     *	  misc_ro_parms, timing_ro_parms, chan_ro_parms,
     *    stream_ro_parms, rw_parms, timing_rw_parms, chan_rw_parms,
     *    stream_rw_parms, voter_info, modem_rw_parms,
     *    frame_header)

c  loads time series data from io_buff into array seis

c  corrects from sensor to ground motion (reverse polarity), 
c  and converts from volts to acceleration in cm/s/s (g = 980.665 cm/s/s)

        character(len=*) :: io_buff    ! io buffer with contents of evt file
        integer isize           ! size of io_buff in bytes
	integer koff   		! offset in io_buff to first frame header
		       		!	(ie, start of time series data)

        real*4, dimension(nsamples) :: seis	! full representation for 3-byte signed integers,
						!   but need real*8 for 4-byte signed integers
						! 3-byte signed integers require 8-character ascii
						!   (-8388608 to 8388607)
						! 4-byte signed integers require 11-character ascii
						!   (-2147483648 to 2147483647)
        integer*4, dimension(nsamples) :: iseis
        character(len=nsamples*4) :: sarray
        integer :: n_corrupt_segments
	integer :: lune

c  - byte/word swapping routines

	integer*4 short_swap
	integer*4 long_swap
	integer*4 real_swap

c  - include files

        include 'evt2smc_headers.txt'

!	include 'altus.h'

!	include 'arch.h'

!	include 'constants.h'

c  - variables

        character(len=6) :: sync_str
	integer(kind=2) :: icheck
	real(kind=8) :: cur_block_time, old_block_time
	integer :: std_frame_size		! typical frame size in bytes, including tag, 
						! initialized using first frame tag
        integer :: bytes_per_sample
        integer :: data_bytes
	integer :: frame_seq_num, last_seq_num
        logical :: verbose = .false.

        integer(kind=4) :: mask
        integer(kind=4) :: test_bit

        integer(kind=4) :: itemp

c -- some initialization ------------------------------------

 	load_evt_seis = 0

c  initialize time series array

	i = 0
	do while (i .lt. stream_ro_parms.nscans*rw_parms.nchannels)
	  i = i + 1
          iseis(i) = 0
	enddo

        sarray = transfer(iseis,sarray)

c  define string for re-synchronizing frames, assuming that the tag preceding the first
c  frame header is not corrupted (note: might want to define this using the tag of the 
c  file header instead) 

	sync_str = io_buff(koff+1:koff+len(sync_str))

        if (verbose) then
	  write(6,'(" sync_str: ",16z3.2)') 
     *		(sync_str(i:i), i=1,len(sync_str))
	endif

c -- begin main loop to process frames of time series data, each 0.1 sec long ------------

	print *, 'Number of frames to process:', stream_ro_parms.duration
	iscan = 0
	joff = 0
	last_seq_num = 1

	iframe = 0
	do while (iframe .lt. stream_ro_parms.duration)		! cycle through frames, 

10	  iframe = iframe + 1
	  ktag = koff

          if (verbose) then
	    print *, 'processing frame', iframe, ', koff =', koff
	  endif

c    first, check the integrity of the tag structure

	  ires = verify(sync_str,io_buff(koff+1:koff+len(sync_str)))
	  if (ires .ne. 0) then
	    write(6,'(/" Corrupted tag for frame ", i6,
     *		" with tag byte offset", i8, 2h (,f6.1," sec)")') 
     *		iframe, koff-LEN_KFF_TAG, 0.1*(iframe-1)
            ktest = index(io_buff(ktag+2:isize-len(sync_str)+1),	! attempt to re-sync
     *          sync_str)
            if (ktest .gt. 0) then
              koff = ktag + ktest
	      n_frames_skipped = (koff-ktag)/std_frame_size
	      print *, '  re-synchronized at offset =', koff,
     *		' (', n_frames_skipped, ' frames skipped)'
              n_corrupt_segments = n_corrupt_segments + 1
              write(lune,'(1h| i5," samples of corrupted data ",
     *		"set = 0. starting at sample",i6,2h (,f8.3,3h s))')
     *          n_frames_skipped*nint(0.1*israte),
     *          (iframe-1)*nint(0.1*israte)+1, 0.1*(iframe-1)
             last_seq_num = last_seq_num + n_frames_skipped
              do while (last_seq_num .gt. 9)
                last_seq_num = last_seq_num - 10
	      enddo
	      iframe = iframe + n_frames_skipped - 1
	      iscan = iscan + n_frames_skipped*nint(0.1*israte)	! increment by number of scans in corrupted frame
	      if (n_frames_skipped .gt. 1)
     *		write(6,'(i5," data samples from",i4," additional",
     *		  " 0.1-sec frames set to 0.")')
     *		  (n_frames_skipped-1)*nint(0.1*israte), 
     *		  (n_frames_skipped-1)
              load_evt_seis = 1
	      go to 10
	    else    
	      print *, 'Failed to re-synchronize'
	      load_evt_seis = -1
	      return
	    endif
	  endif

c    load tag

c          i = 0
c          do while (i .lt. LEN_KFF_TAG)
c            i = i + 1
c            koff = koff + 1
c            kff_tag.load_buff(i:i) = io_buff(koff:koff)
c          enddo

          kff_tag.load_buff = io_buff(koff+1:koff+LEN_KFF_TAG)
          koff = koff + LEN_KFF_TAG

          if (kff_tag.byte_order .eq. 1) then
            ires = long_swap(kff_tag.type)
            ires = short_swap(kff_tag.length)
            ires = short_swap(kff_tag.data_length)
            ires = short_swap(kff_tag.id)
            ires = short_swap(kff_tag.checksum)
          endif

	  if (iframe .eq. 1) std_frame_size = LEN_KFF_TAG 
     *		+ kff_tag.length + kff_tag.data_length

c    verify checksum

	  icheck = 0
	  i = koff
	  iend = i + kff_tag.length + kff_tag.data_length

	  do while (i .lt. iend)
	    i = i + 1
            icheck = icheck + iachar(io_buff(i:i))
	  enddo

	  if (icheck .ne. kff_tag.checksum) then
            write(6,'(/" Checksum error for frame",i6,
     *		" with tag byte offset", i8, 2h (,f6.1," sec)"/
     *		"   header value:",z5.4,"x, calculated value:",z5.4,"x"/
     *		i5," data samples for this 0.1-sec frame set to 0.")')
     *          iframe, koff-LEN_KFF_TAG, 0.1*(iframe-1),
     *		kff_tag.checksum, icheck, nint(0.1*israte)
            ktest = index(io_buff(ktag+2:isize-len(sync_str)+1),	! attempt to re-sync
     *          sync_str)
            if (ktest .gt. 0) then
              koff = ktag + ktest
	      n_frames_skipped = (koff-ktag)/std_frame_size
              n_corrupt_segments = n_corrupt_segments + 1
	      print *, '  re-synchronized at offset =', koff,
     *		' (', n_frames_skipped, ' frames skipped)'
              write(lune,'(1h| i5," samples of corrupted data ",
     *		"set = 0. starting at sample",i6,2h (,f8.3,3h s))')
     *          n_frames_skipped*nint(0.1*israte),
     *          (iframe-1)*nint(0.1*israte)+1, 0.1*(iframe-1)
              last_seq_num = last_seq_num + n_frames_skipped
              do while (last_seq_num .gt. 9)
                last_seq_num = last_seq_num - 10
	      enddo
	      iframe = iframe + n_frames_skipped - 1
	      iscan = iscan + n_frames_skipped*nint(0.1*israte)	! increment by number of scans in corrupted frame
	      if (n_frames_skipped .gt. 1)
     *		write(6,'(i5," data samples from",i4," additional",
     *		  " 0.1-sec frames set to 0.")')
     *		  (n_frames_skipped-1)*nint(0.1*israte), 
     *		  (n_frames_skipped-1)
              load_evt_seis = 1
	      go to 10
	    else    
	      print *, 'Failed to re-synchronize'
	      load_evt_seis = -1
	      return
	    endif
	  endif

c    load frame header

c          i = 0
c          do while (i .lt. LEN_FRAME_HEADER_STRUCT)
c            i = i + 1
c            koff = koff + 1
c            frame_header.load_buff(i:i) = io_buff(koff:koff)
c          enddo

          frame_header.load_buff =
     *          io_buff(koff+1:koff+LEN_FRAME_HEADER_STRUCT)
          koff = koff + LEN_FRAME_HEADER_STRUCT

          if (kff_tag.byte_order .eq. 1) then
            ires = short_swap(frame_header.recorder_id)
            ires = short_swap(frame_header.frame_size)
            ires = short_swap(frame_header.block_time1)
            ires = short_swap(frame_header.block_time2)
            ires = short_swap(frame_header.channel_bitmap)
            ires = short_swap(frame_header.stream_par)
            ires = short_swap(frame_header.msec)
          endif

c	(note: the following conversion is needed because of an alignment problem in the
c		data structure.  see include file frame_header.h)


          block_time = frame_header.block_time2
          jhi = frame_header.block_time1
          call mvbits(jhi,0,16,block_time,16)

	  cur_block_time = dble(block_time) 
     *		+ dble(0.001*frame_header.msec)

c    check frame sequence; based on cycle of 10 (0-9)

          frame_seq_num = ibits(frame_header.frame_status,0,4)
	  if (iframe .gt. 1) then
            if (frame_seq_num-last_seq_num .ne. 1) then
              if (frame_seq_num-last_seq_num .ne. -9) then        ! frame sequencing error
                load_evt_seis = 1

                ksync = 0 ! dummy value, DMB, 02 June 09

                write(6,'(" Warning - frame sequencing error for frame",
     *            i6," at offset",i8/"   frame seq #''s for previous ",
     *            "and current headers:",i6,1h,,i6)')
     *            iframe, ksync-1, last_seq_num, frame_seq_num

                ktest = index(io_buff(ktag+2:isize-len(sync_str)+1),	! attempt to re-sync
     *              sync_str)
                if (ktest .gt. 0) then
                  koff = ktag + ktest
	          n_frames_skipped = (koff-ktag)/std_frame_size
                  n_corrupt_segments = n_corrupt_segments + 1
	          print *, '  re-synchronized at offset =', koff,
     *		    ' (', n_frames_skipped, ' frames skipped)'
                  write(lune,'(1h| i5," samples of corrupted data ",
     *		    "set = 0. starting at sample",i6,2h (,f8.3,3h s))')
     *              n_frames_skipped*nint(0.1*israte),
     *              (iframe-1)*nint(0.1*israte)+1, 0.1*(iframe-1)
                  last_seq_num = last_seq_num + n_frames_skipped
                  do while (last_seq_num .gt. 9)
                    last_seq_num = last_seq_num - 10
	          enddo
	          iframe = iframe + n_frames_skipped - 1
	          iscan = iscan + n_frames_skipped*nint(0.1*israte)	! increment by number of scans in corrupted frame
	          if (n_frames_skipped .gt. 1)
     *		    write(6,'(i5," data samples from",i4," additonal",
     *		      " 0.1 sec frames set to 0.")')
     *		      (n_frames_skipped-1)*nint(0.1*israte), 
     *		      (n_frames_skipped-1)
                  load_evt_seis = 1
	          go to 10
	        else    
	          print *, 'Failed to re-synchronize'
	          load_evt_seis = -1
	          return
	        endif
	      endif
	    endif
	  endif

          last_seq_num = frame_seq_num
	  last_msec = frame_header.msec
	  old_block_time = cur_block_time

c -- load time series from this frame into time series array

c    determine number of data samples in the frame (each frame is 0.10 sec of data)

	  bytes_per_sample = ibits(frame_header.frame_status,6,2) + 1

	  data_bytes = frame_header.frame_size - LEN_FRAME_HEADER_STRUCT

          ksamples = data_bytes/bytes_per_sample

c    now load the data

	  jscan = 0				! scan number within this frame

        do while (jscan .lt. ksamples/rw_parms.nchannels)
	    jscan = jscan + 1
	    joff = (iscan*4) + (4 - bytes_per_sample)	! beginning offset in sarray
							!  for the first channel in the current scan
							!  (adjusted for number of bytes/sample)

	    ichan = 0				! current channel being de-muxed

          do while (ichan .lt. rw_parms.nchannels)
	      ichan = ichan + 1
	      j = joff
	      ibyte = 0

	      do while (ibyte .lt. bytes_per_sample)
		  ibyte = ibyte + 1
		  j = j + 1
		  koff = koff + 1		! increment offset within io_buff
              sarray(j:j) = io_buff(koff:koff)
	if (iscan .eq. 0 .and. ichan .eq. 1) then
          write(6,'(" j, sarray(1:4): ",i19,z10.8,i12)') j,sarray(1:4),
     *          transfer(sarray(1:4),itemp)
        endif

	      enddo

            joff = joff + stream_ro_parms.nscans*4     ! offset to next channel in sarray
	    enddo

	    iscan = iscan + 1		! total number of samples so far in all frames

	  enddo

	  israte = ibits(frame_header.stream_par,0,12)	! sampling rate (in case we need to re-sync)

	enddo

	write(6,'(/" Processed", i6, " frames")') iframe

c    end of loop to process frames
       
c -- do byte-swapping if necessary

        iseis = transfer(sarray,iseis)

c        write(6,'(" after transfer, iseis(1) =         ",z10.8,i12)')
c     *    iseis(1), iseis(1)

        if (kff_tag.byte_order .eq. 1) then
	  i = 0
	  do while (i .lt. nsamples)
	    i = i + 1
            ires = long_swap(iseis(i))
	  enddo
        endif

c        write(6,'(" after byte-swap, iseis(1) =        ",z10.8,i12)')
c     *     iseis(1), iseis(1)

c -- data type for iseis is 4-byte integer, so if samples in file are stored
c    as < 4-byte integers, high bits must be set for samples representing
c    values < 0

	bytes_per_sample = misc_ro_parms.sample_bytes
        if (bytes_per_sample .eq. 0) bytes_per_sample = 3     ! assumed default
        if (bytes_per_sample .lt. 4) then
          mask = ishft(-1,8*bytes_per_sample)
          test_bit = 8*bytes_per_sample - 1
          isample = 0
          do while (isample .lt. nsamples)
            isample = isample + 1
            if (btest(iseis(isample),test_bit))
     *        iseis(isample) = ior(iseis(isample),mask)
          enddo
        endif

c        write(6,'(" after 4-byte adjustment, iseis(1) =",z10.8,i12)')
c     *     iseis(1), iseis(1)

c -- convert from digital counts to acceleration and from sensor motion to ground motion

	write(6,'("  Ch   scale (cm/s/s/count)")')

	icount = 0	! counter for number of channels processed
	inst_ch = 0	! Physical channel in recorder
        mux_ch = 0      ! multiplexed channel

        print *, 'rw_parms.channel_bitmap:', rw_parms.channel_bitmap

        do while (icount .lt. rw_parms.nchannels)	! loop through channels
	  icount = icount + 1

c	find the next physical channel that was recorded

        
          if (rw_parms.channel_bitmap .ne. 0) then
            do while (.not. btest(rw_parms.channel_bitmap,inst_ch))
              inst_ch = inst_ch + 1
            enddo
          endif
	  inst_ch = inst_ch + 1

	  mux_ch = mux_ch + 1

          scale = chan_rw_parms(inst_ch).fullscale*g/
     *		(chan_rw_parms(inst_ch).sensitivity*2**(24-1))

	  select case (chan_rw_parms(inst_ch).sensor_type)  ! correct for V --> grond motion convention

	    case(10)	! FBA-11  (-V --> -ground motion for FBA's)
	      scale = -scale
	    case(11)	! FBA-4g
	      scale = -scale
	    case(12)	! FBA-2g
	      scale = -scale
	    case(13)	! FBA-1g
	      scale = -scale
	    case(14)	! FBA-0.5g
	      scale = -scale
	    case(15)	! FBA-0.25g
	      scale = -scale
	    case(16)	! FBA-0.1g
	      scale = -scale
	    case(20)	! FBA-23
	      scale = -scale
	    case(30)	! WR-1
	    case(32)	! Episensor (+V --> +ground motion)
	    case(33)	! S6000
	    case(34)	! Mark L22
	    case(35)	! Mark L4C
	    case(36)	! CMG3
	    case(37)	! CMG3T
	    case(38)	! CMG40T
	    case(39)	! CMG5
	    case(40)	! KS-2000
	    case default
	      print *, 'Warning: for chan',inst_ch,
     :  	 ' sensor type is undefined'

	  end select

	  if (chan_rw_parms(inst_ch).re_map .lt. 0)	! correction for polarity inversion
     *	    scale = -scale			   	! from channel re-mapping
						
	  write(6,'(i4,1pe16.5e2)') inst_ch, scale

          isample = (mux_ch-1)*stream_ro_parms.nscans
          do while (isample .lt. mux_ch*stream_ro_parms.nscans)
	    isample = isample + 1
            seis(isample) = scale*iseis(isample)
	  enddo

	enddo

90	continue

	return

	end
        subroutine altus_time(time, year, month, day_of_month,
     *          day_of_year, hour, minute, second, gps_roll)

c  converts altus time (secs since Jan 1, 1980) to year, month,
c  day, Julian day, hour, minute, second

c  gps_roll is a flag to indicate whether a correction was made
c  (see below).  0 = no correction, 1 = correction made

	logical*1 isleap	! external function

	integer*4 time, year, month, day_of_month, hour, minute, second
	integer*4  day_of_year

	integer mon(12)
	integer dayz
	integer gps_roll

	data mon/31,28,31,30,31,30,31,31,30,31,30,31/
c	data mon/0,31,59,90,120,151,181,212,243,273,304,334/

c        print *, '(cvt_time) time =', time
c        print *, '(cvt_time) gps_roll =', gps_roll

c --------   fix for GPS rollover that occurred Aug22/23, 1999
c            where Aug 23, 1999 --> Jan 7, 1980

c	assume dates prior to Jan 1, 1988 are suspect

c	252547200 = secs since Jan 1, 1980 until Jan  1, 1988 = 2923 days * 86400 sec/day
c	619315200 = secs since Jan 7, 1980 until Aug 23, 1999 = 7168 days * 86400 sec/day

        gps_roll = 0
c        print *, '(cvt_time) gps_roll =', gps_roll
	if (time .lt. 252547200) then
	  time = time + 619315200	! secs since Jan 7, 1980
	  gps_roll = 1
	endif

c -----------   end of fix

	second = mod(time,60)
	time = time/60

	minute = mod(time,60)
	time = time/60

	hour = mod(time,24)
	time = time/24

	year = 1980 + (time/1461)*4
	time = mod(time,1461)

	if (time .ge. 366) then
	  time = time - 366
	  year = year + 1
	  year = year + time/365
	  time = mod(time,365)
	endif

	day_of_year = time + 1

	dayz = day_of_year

c -- adjust for leap years

c	if ( ((mod(year,4) .eq. 0) .and. (mod(year,100) .ne. 0))  .or. 
c    *		(mod(year,400) .eq. 0) ) then

	if (isleap(year)) then

	  if (day_of_year .eq. 60) then
	    month = 2
	    day_of_month = 29
	    return
	  else if (day_of_year .gt. 60) then
	    dayz = dayz - 1
	  endif
	
	endif

c -- month and day_of_month

	day_of_month = dayz
	i = 0
	do while (i .lt. 12)
	  i = i + 1
	  if (day_of_month .le. mon(i)) then
	    month = i
	    return
	  endif
	  day_of_month = day_of_month - mon(i)
	enddo

	return

	end

c ------------------------------------------------------------------------

        logical*1 function isleap(year)

	integer*4 year

        isleap = .false.
	if ( ((mod(year,4) .eq. 0) .and. (mod(year,100) .ne. 0))  .or. 
     *          (mod(year,400) .eq. 0) ) isleap = .true.
	return
	end

	integer function load_evt_header(io_buff, isize, koff,
     *    kff_tag, kff_file_descr,
     *	  misc_ro_parms, timing_ro_parms, chan_ro_parms,
     *    stream_ro_parms, rw_parms, timing_rw_parms, chan_rw_parms,
     *    stream_rw_parms, voter_info, modem_rw_parms,
     *	  frame_header)

        character(len=*) io_buff    	! contents of evt file
	integer isize  			! size of io_buff, in bytes
	integer koff   			! returns offset in bytes to first frame header in io_buff
		       			!	(ie, start of time series data)

c  - byte/word swapping routines

	integer*4 short_swap
	integer*4 long_swap
        integer*4 real_swap

c  - includes

        include 'evt2smc_headers.txt'

!	include 'altus.h'

!	include 'arch.h'

c  - variables

	integer*4 ires

        integer*4 year, month, day_of_month, day_of_year
        integer*4 hour, minute, second
	integer*4 start_time
	integer*2 start_time_msec
        integer*2 icheck
        integer*2 n_data_bytes
        integer phys_ch
        integer inv
	integer*4 sensor_serial_num

	logical :: verbose = .true.

c -- begin main routine -----------------------------------------------------------

	load_evt_header = 0

c -- load initial file tag

	koff = 0

c        i = 0
c        do while (i .lt. LEN_KFF_TAG)
c          i = i + 1
c          koff = koff + 1
c          kff_tag.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        kff_tag.load_buff = io_buff(koff+1:koff+LEN_KFF_TAG)
        koff = koff + LEN_KFF_TAG

        if (kff_tag.byte_order .eq. 1) then
          ires = long_swap(kff_tag.type)
          ires = short_swap(kff_tag.length)
          ires = short_swap(kff_tag.data_length)
          ires = short_swap(kff_tag.id)
          ires = short_swap(kff_tag.checksum)
        endif

	if (verbose) then
          print *, 'kff_tag.sync: ', kff_tag.sync
          print *, 'kff_tag.byte_order: ', kff_tag.byte_order
          print *, 'kff_tag.version: ', kff_tag.version
          print *, 'kff_tag.instrument_type: ', kff_tag.instrument_type
          print *, 'kff_tag.type: ', kff_tag.type
          print *, 'kff_tag.length: ', kff_tag.length
          print *, 'kff_tag.data_length: ', kff_tag.data_length
          print *, 'kff_tag.id: ', kff_tag.id
          print *, 'kff_tag.checksum: ', kff_tag.checksum
	endif

c  verify checksum for file header

	icheck = 0
        i = koff
        iend = i + kff_tag.length

 	do while (i .lt. iend)
	  i = i + 1
          icheck = icheck + iachar(io_buff(i:i))
	enddo

	if (icheck .ne. kff_tag.checksum) then
	  write(6,'(" Checksum error in file header: should be",z5.4,
     *		"x but calculated",z5.4,"x")') kff_tag.checksum, icheck
c!	  load_evt_header = -1
c!	  go to 90
	endif

c -- begin loading file header:

c    file descriptor

c        i = 0
c        do while (i .lt. LEN_KFF_FILE_DESCR)
c          i = i + 1
c          koff = koff + 1
c          kff_file_descr.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        kff_file_descr.load_buff =
     *    io_buff(koff+1:koff+LEN_KFF_FILE_DESCR)
        koff = koff + LEN_KFF_FILE_DESCR

        if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(kff_file_descr.header_version)
          ires = short_swap(kff_file_descr.header_bytes)
        endif

c    misc ro parameters

c        i = 0
c        do while (i .lt. LEN_MISC_RO_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          misc_ro_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        misc_ro_parms.load_buff =
     *    io_buff(koff+1:koff+LEN_MISC_RO_STRUCT)
        koff = koff + LEN_MISC_RO_STRUCT

        if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(misc_ro_parms.installed_chan)
          ires = short_swap(misc_ro_parms.max_channels)
          ires = short_swap(misc_ro_parms.sys_blk_version)
          ires = short_swap(misc_ro_parms.boot_blk_version)
          ires = short_swap(misc_ro_parms.app_blk_version)
          ires = short_swap(misc_ro_parms.dsp_blk_version)
          ires = short_swap(misc_ro_parms.battery_voltage)
          ires = short_swap(misc_ro_parms.crc)
          ires = short_swap(misc_ro_parms.flags)
          ires = short_swap(misc_ro_parms.temperature)
c          ires = short_swap(misc_ro_parms.wordpad(1))
c          ires = short_swap(misc_ro_parms.wordpad(2))
c          ires = short_swap(misc_ro_parms.wordpad(3))
c          ires = long_swap(misc_ro_parms.dwordpad(1))
c          ires = long_swap(misc_ro_parms.dwordpad(2))
c          ires = long_swap(misc_ro_parms.dwordpad(3))
c          ires = long_swap(misc_ro_parms.dwordpad(4))
        endif

	if (verbose) 
     *	  print *, 'Max channels =', misc_ro_parms.max_channels

c    timing ro parameters

c        i = 0
c        do while (i .lt. LEN_TIMING_RO_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          timing_ro_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        timing_ro_parms.load_buff =
     *    io_buff(koff+1:koff+LEN_TIMING_RO_STRUCT)
        koff = koff + LEN_TIMING_RO_STRUCT

        if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(timing_ro_parms.gps_lock_fail_count)
          ires = short_swap(timing_ro_parms.gps_update_rtc_count)
          ires = short_swap(timing_ro_parms.acq_delay)
          ires = short_swap(timing_ro_parms.gps_latitude)
          ires = short_swap(timing_ro_parms.gps_longitude)
          ires = short_swap(timing_ro_parms.gps_altitude)
          ires = short_swap(timing_ro_parms.dac_count)
c	   ires = short_swap(timing_ro_parms.wordpad)
          ires = short_swap(timing_ro_parms.gps_last_drift(1))
          ires = short_swap(timing_ro_parms.gps_last_drift(2))
          ires = long_swap(timing_ro_parms.gps_last_turn_on_time(1))
          ires = long_swap(timing_ro_parms.gps_last_turn_on_time(2))
          ires = long_swap(timing_ro_parms.gps_last_update_time(1))
          ires = long_swap(timing_ro_parms.gps_last_update_time(2))
          ires = long_swap(timing_ro_parms.gps_last_lock_time(1))
          ires = long_swap(timing_ro_parms.gps_last_lock_time(2))
c	   ires = long_swap(timing_ro_parms.dwordpad(1))
c	   ires = long_swap(timing_ro_parms.dwordpad(2))
c          ires = long_swap(timing_ro_parms.dwordpad(3))
c          ires = long_swap(timing_ro_parms.dwordpad(4))
        endif

c    channel ro parameters

	ichan = 0
	do while (ichan .lt. max(misc_ro_parms.max_channels,12))

	  ichan = ichan + 1

c          i = 0
c          do while (i .lt. LEN_CHAN_RO_STRUCT)
c            i = i + 1
c            koff = koff + 1
c            chan_ro_parms(ichan).load_buff(i:i) = io_buff(koff:koff)
c          enddo

          chan_ro_parms(ichan).load_buff =
     *      io_buff(koff+1:koff+LEN_CHAN_RO_STRUCT)
          koff = koff + LEN_CHAN_RO_STRUCT

          if (kff_tag.byte_order .eq. 1) then
            ires = long_swap(chan_ro_parms(ichan).max_peak)
            ires = long_swap(chan_ro_parms(ichan).max_peak_offset)
            ires = long_swap(chan_ro_parms(ichan).min_peak)
            ires = long_swap(chan_ro_parms(ichan).min_peak_offset)
            ires = long_swap(chan_ro_parms(ichan).mean)
            ires = long_swap(chan_ro_parms(ichan).aq_offset)
c            ires = long_swap(chan_ro_parms(ichan).dwordpad(1))
c            ires = long_swap(chan_ro_parms(ichan).dwordpad(2))
c            ires = long_swap(chan_ro_parms(ichan).dwordpad(3))
          endif

	enddo

c    stream ro parameters

c        i = 0
c        do while (i .lt. LEN_STREAM_RO_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          stream_ro_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        stream_ro_parms.load_buff =
     *    io_buff(koff+1:koff+LEN_STREAM_RO_STRUCT)
        koff = koff + LEN_STREAM_RO_STRUCT

        if (kff_tag.byte_order .eq. 1) then
          ires = long_swap(stream_ro_parms.start_time)
          ires = long_swap(stream_ro_parms.trigger_time)
          ires = long_swap(stream_ro_parms.duration)
          ires = short_swap(stream_ro_parms.errors)
          ires = short_swap(stream_ro_parms.flags)
          ires = short_swap(stream_ro_parms.start_time_msec)
          ires = short_swap(stream_ro_parms.trigger_time_msec)
          ires = long_swap(stream_ro_parms.nscans)
          ires = long_swap(stream_ro_parms.trigger_bitmap)
c          ires = long_swap(stream_ro_parms.pad)
        endif

c    rw parameters

c        i = 0
c        do while (i .lt. LEN_RW_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          rw_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        rw_parms.load_buff = io_buff(koff+1:koff+LEN_RW_STRUCT)
        koff = koff + LEN_RW_STRUCT

        if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(rw_parms.serial_number)
          ires = short_swap(rw_parms.nchannels)
          ires = short_swap(rw_parms.elevation)
          ires = real_swap(rw_parms.latitude)
          ires = real_swap(rw_parms.longitude)
          ires = short_swap(rw_parms.user_codes(1))
          ires = short_swap(rw_parms.user_codes(2))
          ires = short_swap(rw_parms.user_codes(3))
          ires = short_swap(rw_parms.user_codes(4))
          ires = long_swap(rw_parms.cutler_bitmap)
          ires = long_swap(rw_parms.channel_bitmap)
        endif

C        print *, 'rw_parms.nchannels =', rw_parms.nchannels

c    timing rw parameters

c        i = 0
c        do while (i .lt. LEN_TIMING_RW_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          timing_rw_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        timing_rw_parms.load_buff =
     *    io_buff(koff+1:koff+LEN_TIMING_RW_STRUCT)
        koff = koff + LEN_TIMING_RW_STRUCT

	if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(timing_rw_parms.local_offset)
          ires = short_swap(timing_rw_parms.wordpad(1))
          ires = short_swap(timing_rw_parms.wordpad(2))
          ires = short_swap(timing_rw_parms.wordpad(3))
          ires = long_swap(timing_rw_parms.dwordpad(1))
          ires = long_swap(timing_rw_parms.dwordpad(2))
          ires = long_swap(timing_rw_parms.dwordpad(3))
          ires = long_swap(timing_rw_parms.dwordpad(4))
        endif

c    channel rw parameters

        if (verbose) write(6,'(
     *   "   logical physical",19x,"sens",23x,"map"/
     *   "      ch      ch    type   S/N   az   V/g   damp",
     *   " nat freq  gain  inv")')

	ichan = 0

	do while (ichan .lt. max(misc_ro_parms.max_channels,12))

	  ichan = ichan + 1

c          i = 0
c          do while (i .lt. LEN_CHAN_RW_STRUCT)
c            i = i + 1
c            koff = koff + 1
c            chan_rw_parms(ichan).load_buff(i:i) = io_buff(koff:koff)
c          enddo

          chan_rw_parms(ichan).load_buff =
     *      io_buff(koff+1:koff+LEN_CHAN_RW_STRUCT)
          koff = koff + LEN_CHAN_RW_STRUCT

          if (kff_tag.byte_order .eq. 1) then
            ires = short_swap(
     *          chan_rw_parms(ichan).sensor_serial_number_ext)
            ires = short_swap(chan_rw_parms(ichan).north)
            ires = short_swap(chan_rw_parms(ichan).east)
            ires = short_swap(chan_rw_parms(ichan).up)
            ires = short_swap(chan_rw_parms(ichan).altitude)
            ires = short_swap(chan_rw_parms(ichan).azimuth)
            ires = short_swap(chan_rw_parms(ichan).sensor_type)
            ires = short_swap(chan_rw_parms(ichan).sensor_serial_number)
            ires = short_swap(chan_rw_parms(ichan).gain)
            ires = short_swap(chan_rw_parms(ichan).sta_lta_ratio)
            ires = real_swap(chan_rw_parms(ichan).fullscale)
            ires = real_swap(chan_rw_parms(ichan).sensitivity)
            ires = real_swap(chan_rw_parms(ichan).damping)
            ires = real_swap(chan_rw_parms(ichan).natural_frequency)
            ires = real_swap(chan_rw_parms(ichan).trigger_threshold)
            ires = real_swap(chan_rw_parms(ichan).detrigger_threshold)
            ires = real_swap(
     *          chan_rw_parms(ichan).alarm_trigger_threshold)
          endif

	  if (verbose) then
            if (chan_rw_parms(ichan).re_map .ge. 0) then
              inv = 0
              phys_ch = chan_rw_parms(ichan).re_map + 1
            else
              inv = 1
              phys_ch = chan_rw_parms(ichan).re_map + 1 - '80'x
            endif
	    sensor_serial_num =
     *		chan_rw_parms(ichan).sensor_serial_number
	    jhi = chan_rw_parms(ichan).sensor_serial_number_ext
	    call mvbits(jhi,0,16,sensor_serial_num,16)
           write(6,'(i8,i8,i7,i7,i5,f7.3,f6.2,f9.3,i5,i5,1x,
     *          1h(,z2.2,1h))')
     *          ichan, phys_ch,
     *          chan_rw_parms(ichan).sensor_type,
     *		sensor_serial_num,
     *		chan_rw_parms(ichan).azimuth,
     *		chan_rw_parms(ichan).sensitivity,
     *		chan_rw_parms(ichan).damping,
     *		chan_rw_parms(ichan).natural_frequency,
     *		chan_rw_parms(ichan).gain,
     *          inv, chan_rw_parms(ichan).re_map
          endif

	enddo

c    stream rw parameters

c        i = 0
c        do while (i .lt. LEN_STREAM_RW_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          stream_rw_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        stream_rw_parms.load_buff =
     *    io_buff(koff+1:koff+LEN_STREAM_RW_STRUCT)
        koff = koff + LEN_STREAM_RW_STRUCT

        if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(stream_rw_parms.event_number)
          ires = short_swap(stream_rw_parms.sps)
          ires = short_swap(stream_rw_parms.apw)
          ires = short_swap(stream_rw_parms.pre_event)
          ires = short_swap(stream_rw_parms.post_event)
          ires = short_swap(stream_rw_parms.min_run_time)
          ires = short_swap(stream_rw_parms.trigger_threshold)
          ires = short_swap(stream_rw_parms.detrigger_threshold)
          ires = short_swap(stream_rw_parms.timeout)
          ires = short_swap(stream_rw_parms.tx_blk_size)
          ires = short_swap(stream_rw_parms.buffersize)
          ires = short_swap(stream_rw_parms.sample_rate)
          ires = long_swap(stream_rw_parms.tx_chan_map)
c          ires = long_swap(stream_rw_parms.dwordpad(1))
c          ires = long_swap(stream_rw_parms.dwordpad(2))
        endif

c    voter info

	ivoter = 0
	do while (ivoter .lt. max(misc_ro_parms.max_channels,12)+3)
	  ivoter = ivoter + 1

c          i = 0
c          do while (i .lt. LEN_VOTER_INFO_STRUCT)
c            i = i + 1
c            koff = koff + 1
c            voter_info(ivoter).load_buff(i:i) = io_buff(koff:koff)
c          enddo

          voter_info(ivoter).load_buff =
     *      io_buff(koff+1:koff+LEN_VOTER_INFO_STRUCT)
          koff = koff + LEN_VOTER_INFO_STRUCT

          if (kff_tag.byte_order .eq. 1) then
            ires = short_swap(voter_info(ivoter).weight)
          endif

          if (.false.) then
            write(6,'(" voter_info(",i2,").weight =",i10,z5.4)')
     *      ivoter, voter_info(ivoter).weight, voter_info(ivoter).weight
          endif

        enddo

c    modem rw parameters

c        i = 0
c        do while (i .lt. LEN_MODEM_RW_STRUCT)
c          i = i + 1
c          koff = koff + 1
c          modem_rw_parms.load_buff(i:i) = io_buff(koff:koff)
c        enddo

        modem_rw_parms.load_buff =
     *    io_buff(koff+1:koff+LEN_MODEM_RW_STRUCT)
        koff = koff + LEN_MODEM_RW_STRUCT

        if (kff_tag.byte_order .eq. 1) then
          ires = short_swap(modem_rw_parms.cell_start_time(1))
          ires = short_swap(modem_rw_parms.cell_start_time(2))
          ires = short_swap(modem_rw_parms.cell_start_time(3))
          ires = short_swap(modem_rw_parms.cell_start_time(4))
          ires = short_swap(modem_rw_parms.cell_start_time(5))
          ires = short_swap(modem_rw_parms.flags)
        endif

c    finally, verify byte offset

	if (koff-LEN_KFF_TAG .ne. kff_file_descr.header_bytes) then

          write(6,'(" Inconsistent final byte offset for file header: "/
     *          "  header value =",z5.4,"x, actual value =",z5.4,1hx)')
     *		kff_file_descr.header_bytes, koff-LEN_KFF_TAG

            load_evt_header = -1

	endif

90	continue

	return

	end
c -- byte/word swapping routines ------------------------------------------

	integer function real_swap (r)

c    byte- and word-swap a real variable

c    returns -1 upon failure.

	real*4 r
	byte b(4), btemp

c        equivalence (b(1), r)	! in lieu of using transfer function below

	real_swap = -1

	b = transfer(r,b)

	btemp = b(1)
	b(1) = b(4)
	b(4) = btemp
	btemp = b(3)
	b(3) = b(2)
	b(2) = btemp

	r = transfer(b,r)

	real_swap = 0
	return
	end

c ------------------------------------------------------------------------------

	integer function short_swap (i)

c -- byte-swap a short integer

c    returns -1 upon failure.

        integer*2 i
        byte b(2), btemp

c        equivalence (b(1), i)	! in lieu of using transfer function below

	short_swap = -1

        b = transfer(i,b)

        btemp = b(1)
        b(1) = b(2)
        b(2) = btemp

        i = transfer(b,i)

	short_swap = 0
	return
	end

c ------------------------------------------------------------------------------

	integer function long_swap (l)

c -- byte- and word-swap a long integer

c    returns -1 upon failure.

	integer*4 l
	byte b(4), btemp
c        equivalence (b(1), l)	! in lieu of using transfer function below

	long_swap = -1

        b = transfer(l,b)

        btemp = b(1)
        b(1) = b(4)
        b(4) = btemp
        btemp = b(2)
        b(2) = b(3)
        b(3) = btemp

        l = transfer(b,l)

	long_swap = 0
	return
	end
